Sync zoneinfo database with tzdata2018d from ftp://ftp.iana.org/tz/releases
[dragonfly.git] / UPDATING
CommitLineData
d2a0decc
MD
1# Updating Information for DragonFly users.
2#
3#
4# This file should warn you of any pitfalls which you might need to work around
5# when trying to update your DragonFly system. The information below is
6# in reverse-time order, with the latest information at the top.
7#
8# If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9# mailing list with the details.
d2a0decc 10
2c15346d
SW
11+-----------------------------------------------------------------------+
12+ UPGRADING DRAGONFLY FROM 4.8 TO LATER VERSIONS +
13+-----------------------------------------------------------------------+
14
15FFS_ROOT OPTION DISABLED
16------------------------
17
18The FFS_ROOT option has been made a no-op and will be completely removed
19at some point in the future. Users with a custom kernel configuration
20can remove this option from it now.
21
3522bdfe
SW
22+-----------------------------------------------------------------------+
23+ UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS +
24+-----------------------------------------------------------------------+
25
7efec73e
SW
26AHC, AHD, AIC, NCV, NSP AND STG DRIVERS REMOVED
27-----------------------------------------------
9ef43fc3 28
7efec73e
SW
29They were all in our X86_64_GENERIC kernel configuration file, along with
30the AHC_REG_PRETTY_PRINT and AHD_REG_PRETTY_PRINT options, so any custom
31configuration files derived from it need adjustment.
9ef43fc3 32
be813d7a
SW
33PORTAL FILE SYSTEM REMOVED
34--------------------------
35
36It has been broken for a long time now.
37
5cc5a38c 38BINUTILS 2.27 REPLACES 2.24, PRIMARY
39------------------------------------
40
41The oldest of the two versions of Binutils, version 2.24, was removed
42and replaced with Binutils 2.27. It becomes the primary version version
43of binutils and version 2.25 becomes the alternate.
44
45The accepted values of BINUTILSVER are now "binutils227" (default) and
46"binutils225". The building of Binutils 2.25 can be prevented by setting
47NO_ALTBINUTILS=yes in make.conf.
48
d6e8ab2d
SW
49COMPAT_43 KERNEL OPTION REMOVED
50-------------------------------
51
52It was commented out in our default configs for several years now, but
53might still be present in custom configs created before Nov. 2011.
54
adfb2c71
JM
55OPENSSL REMOVED
56---------------
57
58OpenSSL has been removed from base and replaced with a private version of
59LibreSSL. The previously installed OpenSSL libraries, headers, and man
60pages will remain on the system unless the "make upgrade" command is
61specifically instructed to remove them. To do this, define
62REMOVE_OPENSSL_FILES for the upgrade command, e.g.
63"make upgrade REMOVE_OPENSSL_FILES=yes"
64
5b245968
MD
6528-Oct-2016: openssl has been replaced by ressl. It is recommended that any
66stale OpenSSL files be removed to avoid configuration scripts from using
67the stale and potentially vulnerable version, but all binaries that are
68dynamically linked to the OpenSSL libraries should be rebuilt first to
69avoid breakage.
adfb2c71 70
9682bad8
TN
71OPENSSH HPN REMOVED
72-------------------
73
74It has become too cumbersome to maintain HPN patches in OpenSSH in base.
75To use OpenSSH in base remove HPN config, if you have added it.
76Check files below for HPN config, see a few lines below.
77 /etc/ssh/ssh_config, /etc/ssh/sshd_config, ~/.ssh/config
78sshd(8) will fail to start if HPN config is used.
79
80NOTE: HPN config in sshd_config will prohibit remote access to host using ssh.
81
82HPN config:
83HPNDisabled
84HPNBufferSize
85TcpRcvBuf
86TcpRcvBufPoll
87NoneEnabled
88NoneSwitch
89cipher MTR-AES-CTR
90cipher NONE
91
92OpenSSH HPN is a patch set to OpenSSH providing higher performance under some
93circumstances, especially for networking.
94If HPN functionality is needed, install security/openssh from dports.
95
859c2e53
SW
96CS, EX AND VX DRIVERS REMOVED
97-----------------------------
3522bdfe 98
859c2e53
SW
99The cs(4), ex(4) and vx(4) drivers have been removed. They were very
100old and its doubtful they ever worked properly in x86_64 but they were
101in X86_64_GENERIC, so custom configurations derived from it have to be
3a609f3d 102adjusted.
3522bdfe 103
82aec1d3
FT
104+-----------------------------------------------------------------------+
105+ UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS +
106+-----------------------------------------------------------------------+
107
f1826c3e
SW
108AMD REMOVED
109-----------
110
111The am-utils automounter suite has been removed. It stopped working
112at some point and was never fixed. autofs(5) and the associated
113userland has been brought in from FreeBSD and replaces it.
114
c222305f
SW
115AN DRIVER REMOVED
116-----------------
82aec1d3 117
c222305f
SW
118The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
119config file, so any configurations derived from it have to be adjusted.
82aec1d3 120
c222305f
SW
121/DEV/DRI GROUP CHANGED
122----------------------
123
124The default group assigned to /dev/dri entries has been changed
125from 'wheel' to 'video' with the id of '44'. If you want to have
126access to the dri devices please add yourself to the video group
127with:
128
129# pw groupmod video -m $USER
82aec1d3 130
dbf3d3ba
JM
131+-----------------------------------------------------------------------+
132+ UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS +
133+-----------------------------------------------------------------------+
134
54af9d02
SW
135DSCHED REMOVED
136--------------
137
138dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
139in our default kernel config file. So the DSCHED_FQ option has been turned
140into a no-op for now and can be removed from custom configurations.
141
68ef81ed
SW
142EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
143-------------------------------------------------
144
145The est(4) driver has been removed. All CPUs it supported (except one)
146were 32 bits only. Those who are still using the Core 2 Duo T7500 should
147report back if there are any issues with this CPU and our regular ACPI
148P-state support.
149
150Also, compile_et(1) and com_err(3) have been removed as well. They
151should have been removed along with kerberos support, back in 2009.
152
dbf3d3ba
JM
153SEVERAL LOCALES RENAMED
154-----------------------
155
156Several locales were using obsolete and misleading names, and thus have
157been adjusted to current standards. Any users of the following locales
158need to select alternates:
159
160DFLY 4.2 locale DFLY 4.4 alterative locale
161--------------- ------------------------------------
162mn_MN.UTF-8 mn_Cyrl_MN.UTF-8
163no_NO.UTF-8 nb_NO.UTF-8 or nn_NO.UTF-8
164no_NO.ISO8859-1 nb_NO.ISO8869-1 or nn_NO.ISO8859-1
165no_NO.ISO8859-15 nb_NO.ISO8859-15 or nn_NO.ISO8859-15
166sr_YU.UTF-8 sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
167sr_YU.ISO8859-5 sr_Cyrl_RS.ISO8859-5
168sr_YU.ISO8859-2 sr_Latn_RS.ISO8859-2
169zh_CN.GBK zh_Hans_CN.GBK
170zh_CN.UTF-8 zh_Hans_CN.UTF-8
171zh_CN.eucCN zh_Hans_CN.eucCN
172zh_CN.GB2312 zh_Hans_CH.GB2312
173zh_CN.GB18030 zh_Hans_CH.GB18030
174zh_HK.Big5HKSCS zh_Hant_HK.Big5HKSCS
175zh_HK.UTF_8 zh_Hant_HK.UTF-8
176zh_TW.Big5 zh_Hant_TW.Big5
177zh_TW.UTF-8 zh_Hant_TW.UTF-8
178
2a617999
SW
179+-----------------------------------------------------------------------+
180+ UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS +
181+-----------------------------------------------------------------------+
182
65c3b857
JM
183BINUTILS 2.25 REPLACES 2.22, PRIMARY
184------------------------------------
185
186The oldest of the two versions of Binutils, version 2.22, was removed
187and replaced with Binutils 2.25. It becomes the primary version version
188of binutils and version 2.24 becomes the alternate. There are 8 current
189CVE written against 2.24, so for security reasons version 2.25 should
190always be used.
191
192The accepted values of BINUTILSVER are now "binutils225" (default) and
193"binutils224". The building of Binutils 2.24 can be prevented by setting
194NO_ALTBINUTILS=yes in make.conf.
195
72b78560
JM
196LOADER OPTIONS CHANGED
197----------------------
198
199Right after the development branch started, the Fred art accompanying the
200loader menu was improved. The line between Fred and the menu was removed
201by default (but can optionally be returned) and the placement shifted as
202a result. The drawing was improved, and the colored version was improved,
203changing the eyes and wing color from white to red. A new color version
204of Fred was added, one with a blue scheme.
205
206The loader menu defaults have changed since release 4.0: The vertical
207line was removed, the loader is displayed in color by default*, and the
208blue scheme is used.
209
210The loader.conf changes are:
211loader_color: option has been removed
212loader_plain: option has been added, it changed menu to monochrome
213fred_is_red: changes color scheme from blue to red
214fred_is_blue: option existed only on 4.1, it has been removed
215fred_separated: Adds line between Fred and menu (as seen previously)
216
217* If loader.conf defines "console" as "comconsole" or "console" is defined
218 in the environment as "comconsole" then color will not be displayed,
219 even if loader_plain value is "NO".
220
cbab4ab1
JM
221SENDMAIL REMOVED FROM BASE
222--------------------------
223
224The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
225If the system being upgraded is still configured to use the sendmail
226binaries from base, the "make upgrade" command will fail.
227
228The administrator must change /etc/mail/mailer.conf to switch the
229mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
230command that permanently removes sendmail executables and could
231potentially break a running mail server.
232
233Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
234detailed instructions on how to configure the MTA selection.
235
a7ac1ee9
SW
236_KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
237--------------------------------------------
238
239The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
240no-ops. They can be removed from custom kernel configurations.
241
aa7c3d6b
FT
242SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
243--------------------------------------------
244
245Many more sound devices may be detected.
246
247If the default device choosen isn't to your liking, setting the sysctl
248hw.snd.default_unit to a different number will change it.
249
60a260ad
SW
250SCTP SUPPORT DROPPED
251--------------------
252
253Support for the SCTP protocol has been removed.
254
2a617999
SW
255OLD USB DRIVERS REMOVED
256-----------------------
257
258The old USB stack, along with the kernel config option "device oldusb"
259and the make.conf variable "WANT_OLDUSB" have been removed. This means
260that for custom kernel configuration files which were derived from a
261GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
262various (old USB stack specific) devices will now complain about being
263unknown:
264
265 * oldusb (obviously)
266 * natausb (not yet ported to usb4bsd)
267 * rue (not yet ported to usb4bsd)
268 * ugen (no longer needed in usb4bsd)
269 * urio (not yet ported to usb4bsd)
270 * uscanner (no longer needed in usb4bsd)
271
272They should be removed or commented out in such custom kernel configs.
273
4e8e707f
JM
274GCC 5
275-----
276
277The GCC 4.4 compiler has been retired. It has been replaced by a GCC 5.1.
278The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
279NO_CXX. The latter was never documented and the latest versions of GCC are
280partially written in C++ so a C++ compiler is no longer optional. In
281practical terms it has not been optional for many years as other base
282components are also written in C++. The resource savings by avoiding
283building Objective-C compiler is so small, the complexity added by NO_OBJC
284internally was deemed a bad tradeoff so that is the reason for its removal.
285Also note that no "info" pages are installed with GCC 5. After this entry
286was originally written, all info pages were removed from DragonFly.
287
288GCC 5.1 has been designated as the primary compiler. As such, there is a
289new make.conf variable, NO_ALTCOMPILER. It will block the rebuilding of
290the designated secondary compiler, GCC 4.7. However, while DPorts
291primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
292if building ports from source is desired, don't block building of the
293secondary compiler.
e9b676f1 294
0055c35b
SW
295+-----------------------------------------------------------------------+
296+ UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS +
297+-----------------------------------------------------------------------+
298
2a617999 299SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
39b3e0a1
SW
300-------------------------------------------
301
302DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
303the default now (even on single-core systems), both for, like, 21 months.
304We kept the options around as no-ops as a convenience, to allow people
305using the same config for the then current release and the then current
306master. That period is now over, so any configs still having those
307options have to be adjusted.
308
10ceb702
SW
309SYSVIPC SYSCALLS MADE NON-OPTIONAL
310----------------------------------
311
312The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
313now compiled in by default. The options are no-ops for now.
314
79a3e83f
SW
315DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
316--------------------------------------------------------------------
317
318The default driver for those controllers is now mrsas(4) due to reports
319of file system corruption using the mfi(4) driver. The whole issue (and
320how to deal with potential problems when switching) was explained here:
321
322http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
323
324A tunable is provided for letting those controllers still attach via
325the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
326
0055c35b
SW
327OLDER NETWORK DRIVERS MOVED TO I386 ONLY
328----------------------------------------
329
330The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
331and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
332removed in kernel configs derived from X86_64_GENERIC.
333
e19e3c77 334+-----------------------------------------------------------------------+
62d4130d 335+ UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS +
e19e3c77
SW
336+-----------------------------------------------------------------------+
337
a6a7c140
JS
338UPDATE FROM MOST RECENT 3.6
339---------------------------
340
341Versions of 3.6 built before June 25th have a bug where installworld might
342crash during installation of the new initrd. Upgrade to the latest version
343of 3.6 before updating to 3.8 or later.
344
7c87aae6
SW
345ATM, IPX, NCP AND NWFS SUPPORT DROPPED
346--------------------------------------
6f25d555
SW
347
348Support for the IPX and NCP network protocols and for mouting NetWare
7c87aae6 349file systems has been dropped. Dito for ATM protocol support.
6f25d555
SW
350
351INITRD IMAGES NOW INSTALLED BY DEFAULT
352--------------------------------------
353
354An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
355
356Older images installed under the file name of initrd.img will be removed
357automatically by the make upgrade process.
358
f0478b8b
SW
359USB4BSD IS NOW THE DEFAULT USB STACK
360------------------------------------
361
362To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
363replace "device usb" with "device oldusb" in the kernel configuration.
364
e19e3c77
SW
365MORE ISA SUPPORT DROPPED
366------------------------
367
368ISA support has been dropped from the following drivers: adv(4), an(4),
369ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
370si(4), sn(4), and stg(4).
371
9332798a 372+-----------------------------------------------------------------------+
62d4130d 373+ UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS +
9332798a
SW
374+-----------------------------------------------------------------------+
375
c04df145
JS
376ABI CHANGE
377----------
378
379Installed third-party software (dports) will have to be rebuilt after upgrade,
380or reinstalled from binary packages.
381
2b455b95
JS
382UPDATING FROM 3.4 TO 3.6
383------------------------
384
385This only applies for this specific upgrade due to locale changes; it is
386not needed for upgrades after 3.6. Please update in this order:
387
388make buildworld
389make buildkernel
390make installworld
391make installkernel
392*reboot*
393make upgrade
394
395See this mailing list post for details:
396http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
397
9332798a
SW
398CYRIX OPTIONS REMOVED
399---------------------
400
401The following Cyrix related options have been removed: CPU_BTB_EN,
402CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
403CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
404CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
405
406ISA SUPPORT REMOVED FROM RP(4)
407------------------------------
408
409ISA support has been removed from the rp(4) driver. It is now PCI only.
410
64aeb497 411+-----------------------------------------------------------------------+
62d4130d 412+ UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS +
64aeb497
SW
413+-----------------------------------------------------------------------+
414
d88b9605
SW
415COMPAT_SUNOS OPTION REMOVED
416---------------------------
417
418The COMPAT_SUNOS option has been removed. It was meant to provide binary
419compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
420
43f215d7
SW
421ISA SOUND CARD SUPPORT REMOVED
422------------------------------
423
424The following modules have been removed (all for ISA sound cards):
425snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
426
6100d1de
JM
427GCC 4.7
428-------
429
430DragonFly has switched base compilers. GCC 4.7 is now the default
431compiler and GCC 4.4 is the alternative compiler. The "NO_GCC47" make
432variable ceases to work now.
433
434Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
435/etc/make.conf to prohibit GCC 4.4 from building. However, using it is
436highly discouraged. There are a few packages in pkgsrc that do not build
437with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default. At
438this time, it is recommended to keep both compilers on the base system.
439
2089bb7c
SW
440SMP OPTION REMOVED
441------------------
442
443The SMP kernel option has been made a no-op. All kernels now feature SMP
444support. If you have 'options SMP' in your kernel config, you can as well
445remove it.
446
1c297ed0
SW
447DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
448---------------------------------------------------------------------------
640dc18f
SZ
449
450The DEVICE_POLLING kernel option has been made a no-op and it has been
451replaced by IFPOLL_ENABLE. If you have 'options DEVICE_POLLING' in your
452kernel config, you need to change it to IFPOLL_ENABLE.
453
1c297ed0
SW
454Also, the KTR_POLLING kernel option has been removed, so it must be
455removed from kernel configs that have it.
456
558b0a0b
SW
457BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
458---------------------------------------------------
850c4634
SW
459
460The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
461cards will no longer be detected.
462
e6f626a1
SW
463The same has been done for Stallion multiport serial controllers. stli(4)
464has been completely removed (along with the stlload(8) and stlstty(8)
558b0a0b
SW
465utilities) and stl(4) was changed to support only PCI cards. Similarly,
466ISA support was removed from cy(4) too. All these drivers are i386 only.
e6f626a1 467
e98bcb27
SW
468COMPAT_OLDISA OPTION GONE
469-------------------------
470
471The i386 specific COMPAT_OLDISA kernel option has been removed, since
472nothing needs it anymore.
473
c691bb43 474+-----------------------------------------------------------------------+
62d4130d 475+ UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS +
c691bb43
SW
476+-----------------------------------------------------------------------+
477
478APIC_IO OPTION REMOVED
479----------------------
480
481The APIC_IO kernel option is no longer accepted after having been without
482effect for a while. The hw.ioapic_enable tunable now serves its purpose.
483If you have 'options APIC_IO' in your kernel config, you'll have to
484remove it.
485
6d488cc3
SW
486WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
487-----------------------------------------
cf03d6cd
SW
488
489The wdog framework is now compiled into our kernels by default, so the
6d488cc3 490options are no longer needed.
cf03d6cd 491
397ffc5c
SW
492DOSCMD(1) REMOVED
493-----------------
494
495doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
496NO_X make.conf option was removed too.
497
a1404d4f
SW
498GCC 4.7
499-------
500
501GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
502default compiler in base (default is still GCC 4.4).
503
504Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
505NO_GCC47 in /etc/make.conf.
506
2508820f
SW
507USB4BSD
508-------
509
510A new USB stack (from FreeBSD) has been brought in. The following
511modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
512usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
513and uaudio.
514
515It is not yet the default. To activate it, WANT_USB4BSD=yes has to
c7200221
SW
516be put in make.conf and device "usb4bsd" (quotes needed) has to
517replace device usb in the kernel config. After that, a full
518build/install/upgrade cycle is needed.
2508820f
SW
519
520Note that this is experimental and incomplete, but we are interested
521in hearing about issues with it, of course.
522
ae0870a3
SW
523ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
524---------------------------------------------
525
526ISA adapter support was dropped from the aic(4) driver.
527
96386d4b 528+-----------------------------------------------------------------------+
62d4130d 529+ UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS +
96386d4b
SW
530+-----------------------------------------------------------------------+
531
532SEVERAL ISA DRIVERS REMOVED
533---------------------------
534
535The following ISA only drivers have been removed along with a couple of
536associated userland tools:
537
538aha(4)
539asc(4) & sasc(1)
540ctx
541dgb(4)
542el(4)
543gpib
544gsc(4) & sgsc(1)
545ie(4)
546labpc(4)
547le(4)
548mse(4)
549rc(4)
550rdp(4)
551spigot
552tw(4) & xten(1) & xtend(8)
553wl(4) & wlconfig(8)
554wt(4)
555
556Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
557config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
558file.
559
560If buildkernel complains about any of these drivers, just remove them
561from your kernel configuration.
562
919eb219
JM
563BINUTILS 2.20
564-------------
37c5a0db 565Binutils 2.20 has been removed in favor of Binutils 2.22. The accepted
e685772e 566values of BINUTILSVERS are now binutils221 and binutils222 (default).
919eb219 567
83bc1e2a
SW
568BUILDWORLD/-KERNEL PARALLELIZATION WORK
569---------------------------------------
570Due to changes in the way we build with more than one make job, you
571will have to update install(1) and mkdir(1) prior to buildworld if you
572want to build with 'make -j':
573
574cd /usr/src/usr.bin/xinstall; make; make install; make clean
575cd /usr/src/bin/mkdir; make; make install; make clean
576
eca86bd9
SW
577DMA(8) UPGRADE
578--------------
579dma(8) has been upgraded to v0.7 which no longer supports the
580/etc/dma/virtusertable. Some of its functionality has been replaced
581with the MASQUERADE keyword and the EMAIL environment variable (see
582the dma(8) manual page).
583
a4a39c94 584+-----------------------------------------------------------------------+
62d4130d 585+ UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS +
a4a39c94
JS
586+-----------------------------------------------------------------------+
587
b1242318
SW
588GCC 4.4 & BINUTILS 2.21
589-----------------------
30c91f0c 590
b1242318
SW
591GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
592been made DragonFly's default Binutils.
30c91f0c
SW
593
594That means that any settings that set CCVER to 'gcc44' are not needed
595anymore. Instead, CCVER can be set to 'gcc41' to go back to using
596GCC 4.1.
597
b1242318
SW
598It also means that 'binutils221' as a value for BINUTILSVER has no
599effect anymore. 2.17 has been removed and 'binutils220' is available
600as an option.
601
5738210d 602The NO_GCC44 option has been removed and will not affect the build
30c91f0c
SW
603anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
604building in a similar fashion.
605
80abb3be 606Note that you must do a full buildworld/buildkernel for upgrading.
30c91f0c 607
a4a39c94 608pkg_radd settings
c983d16e 609-----------------
a4a39c94
JS
610
611The config file for pkg_radd has moved from /etc/settings.conf to
612/etc/pkg_radd.conf. Save the contents of settings.conf before upgrading
613if this is needed. This warning only applies if /etc/settings.conf
614exists. pkg_radd will continue to work with defaults.
615
b79f66dd 616+-----------------------------------------------------------------------+
72fe41d3 617+ 20100927 +
1bb1cc14 618+ UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD +
b79f66dd
JT
619+-----------------------------------------------------------------------+
620
72fe41d3 621OpenSSL
c983d16e 622--------
72fe41d3
PA
623
624OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
625This shouldn't break any 3rd-party software, but you'll need to recompile your
6263rd-party software if you want it to link against the new version of OpenSSL.
627
8eb0b612 628Loader
c983d16e 629-------
8eb0b612 630
b79f66dd
JT
631A new loader (dloader) has been added which better handles booting from
632multiple kernel/module versions.
633
634To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
635
636 cd /usr/src
637 make buildworld
638 make installworld
639 make upgrade
640 make buildkernel KERNCONF=<KERNELNAME>
641 make installkernel KERNCONF=<KERNELNAME>
642
643Note that you must installworld and run the 'upgrade' target before
644installing the new kernel.
645
8eb0b612 646BIND
c983d16e 647-----
8eb0b612
JS
648
649BIND has been removed from the base system. The ldns and drill tools have
650been added for basic functionality. Use 'drill' where you would normally
651use nslookup or dig, or install BIND from pkgsrc. It's available as
652net/bind95, net/bind96, or net/bind97 as of this writing.
653
654This only affects older systems upgrading to 2.8. New 2.8+ installs
655include BIND as a pkgsrc package.
656
d2a0decc
MD
657+-----------------------------------------------------------------------+
658+ UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM +
659+ GENERAL +
660+-----------------------------------------------------------------------+
984263bc 661
a700883c
SW
662Instructions on how to obtain and maintain DragonFly source code using git
663are in the development(7) manual page.
d2a0decc
MD
664
665To upgrade a DragonFly system from sources you run the following sequence:
666
667 cd /usr/src
668 make buildworld
669 make buildkernel KERNCONF=<KERNELNAME>
670 make installkernel KERNCONF=<KERNELNAME>
671 make installworld
672
673You will also want to run the 'upgrade' target to upgrade your /etc and the
674rest of your system. The upgrade target is aware of stale files created by
675older DragonFly installations and should delete them automatically.
676
677 make upgrade
678
a700883c
SW
679See the build(7) manual page for further information.
680
d2a0decc
MD
681Once you've done a full build of the world and kernel you can do incremental
682upgrades of either by using the 'quickworld' and 'quickkernel' targets
683instead of 'buildworld' and 'buildkernel'. If you have any problems with
a700883c 684the quick targets, try updating your repo first, and then a full buildworld
d2a0decc 685and buildkernel as shown above, before asking for help.
4523a2c0
TN
686
687+-----------------------------------------------------------------------+
688+ UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1 +
689+-----------------------------------------------------------------------+
690
691In 2.1 kernel and modules has moved to boot directory. For most cases
692this is handled automatically by 'make upgrade'. A few cases needs manual
693intervention:
694
695 * When installing a kernel without first doing a make buildworld,
696 installworld and upgrade to the same DESTDIR as kernel:
697 make DESTDIR/boot directory and move kernel and modules into this boot
698 directory; also move kernel.old and modules.old.
699 Typical example is vkernel(7), use (no modules used):
700
701 cd /var/vkernel
702 mkdir boot
703 chflags noschg kernel
704 mv kernel kernel.old boot
705 chflags schg boot/kernel
706
707 * When using a boot-only partition, /boot/loader.rc needs to be edited:
708 delete occurrences of '/boot/'.
709 These occurences can normally be deleted in any case, see loader(8).
d2a0decc
MD
710
711+-----------------------------------------------------------------------+
712+ UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9 +
713+-----------------------------------------------------------------------+
714
715In 1.9 major changes to the disk management infrastructure have taken
716place. make upgrade may not catch all of your disk devices in /dev,
717so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
45e80934
MD
718are all of your disk devices. HOWEVER, from late 2.3 on we run devfs
719and MAKEDEV no longer exists.
d2a0decc
MD
720
721The biggest changes in 1.9 are:
722
723(1) That whole-slice devices such as da0s1 no longer share the same device
724 id as partition c devices such as da0s1c.
725
726(2) The whole-disk device (e.g. da0) is full raw access to the disk,
727 with no snooping or reserved sectors. Consequently you cannot run
728 disklabel on this device. Instead you must run disklabel on a
729 whole-slice device.
730
731(3) The 'compatibility' partitions now use slice 0 in the device name,
732 so instead of da0a you must specify da0s0a. Also, as per (1) above,
733 accessing the disklabel for the compatibility partitions must be
734 done via slice 0 (da0s0).
735
736(4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
737 and CCD now run through the disk management layer and are assigned
738 real disk management devices. VN and CCD in particular do not usually
739 use a MBR and disklabels must be accessed through the compatibility
740 slice 0. Your /etc/ccd.conf file still specifies 'ccd0', though, you
741 don't name it 'ccd0s0' in the config file.
742
743Generally speaking, you have to get used to running fdisk and disklabel on
744the correctly specified device names. A lot of the wiggle, such as running
745disklabel on a partition, has been removed.
746
747+-----------------------------------------------------------------------+
748+ UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD +
749+-----------------------------------------------------------------------+
750
751> Kerberos IV
752-------------
753
754Kerberos IV (eBones) was removed from the tree, please consider moving to
755Kerberos 5 (Heimdal).
756
757> Package Management System
758---------------------------
759
760Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
761management system. The necessary tools to build and maintain packages
762are provided in /usr/pkg/bin and /usr/pkg/sbin. Make sure that these
763directories are in your PATH variable.
764
765In order to obtain a reasonably current snapshot of the pkgsrc tree, use
766the tarball from NetBSD:
767
768 fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
769 cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
770
771This tree can then be kept up to date with cvs update:
772
773 cd /usr/pkgsrc; cvs up
774
775NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
776build and install the pkgsrc bootstrap manually:
777
778 cd /usr/pkgsrc/bootstrap
779 ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
780
781+-----------------------------------------------------------------------+
782+ UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM +
783+ UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO +
784+ DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD) +
785+-----------------------------------------------------------------------+
58116288 786
114580ac 787The compatibility shims for the build environment have been removed, you
58116288
JS
788have to update to DragonFly 1.2 release branch first.
789
1fcc7462
JS
790The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
791The existing configuration can be converted using /etc/pam.d/convert.sh.
792Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
793the pam_skey.so module was retired, you have to remove it manually from
794your configuration, when you convert it.
58116288 795
a3107071
MD
796> Required user and group IDs when upgrading from either FreeBSD or DragonFly
797---------------------
798
799The following users may be missing from your password file. Use vipw and
800add any that are missing:
801
802smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
dcf85892 803_pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
a3107071
MD
804
805The following groups may be missing from your group file. Use vi /etc/group
806and add any that are missing:
807
808smmsp:*:25:
809authpf:*:63:
dcf85892 810_pflogd:*:64:
a3107071
MD
811
812
f419daca 813> Upgrading to DragonFly from FreeBSD
5e0ae0d4 814---------------------
984263bc 815
f419daca
MD
816You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
817FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
818FreeBSD. Note that the DragonFly buildworld target does not try to reuse
819make depend information, it starts from scratch, so no pre-cleaning of the
820object hierarchy is necessary.
821
466bbc10 822 # get the CVS repository (it is placed in /home/dcvs, 500MB).
f419daca
MD
823 # Please use the -h option and a mirror site to pull the
824 # initial repository, but feel free to use the main repository
825 # machine to pull updates.
5010eeb3 826 cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
f419daca
MD
827 # install the source from the CVS hierarchy (remove preexisting
828 # FreeBSD src first) (500MB)
829 cd /usr
830 rm -rf src
50172b1c 831 cvs -R -d /home/dcvs checkout -P src
f419daca
MD
832
833 # build it (500MB used in /usr/obj)
834 #
835 cd /usr/src
836 make buildworld
837 make buildkernel KERNCONF=<KERNELNAME>
984263bc 838
f419daca
MD
839Once you have built DragonFly you have to install it over FreeBSD. Since
840DragonFly does not track changes made by FreeBSD to its include file
841hierarchy and include file pollution can cause all sorts of unexpected
842compilation issues to come up, it is best to wipe your include hierarchy
843prior to installing DragonFly. Note that you should not wipe any installed
844FreeBSD header files or binaries until after you have successfully completed
845the build steps above.
fb12f484 846
f419daca
MD
847 rm -rf /usr/include
848 mkdir /usr/include
849 make installkernel KERNCONF=<KERNELNAME>
850 make installworld
fb12f484 851
b8cbf045 852Then you need to upgrade your system. DragonFly's 'make upgrade' target
f419daca 853will unconditionally upgrade the /etc files that sysops do not usually
b8cbf045
SW
854mess around with, such as the files in /etc/rc.d. It will also remove any
855obsolete files such as utilities and manpages that have been removed from
856the system since the version you're coming from. If you are unsure we
857recommend that you make a backup of at least your /etc before applying
858this step. Note that DragonFly's RC system is basically RCNG from
859FreeBSD-5, but there are some differences in the contents of the RC files.
f419daca
MD
860
861 make upgrade
862
b8cbf045
SW
863NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
864Doing so might leave your system in an unusable state.
865
f419daca 866Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
b8cbf045
SW
867/usr/bin, and /usr/lib, and remove any stale files that you find. Please
868report these files to the DragonFly developers so that they can be added to
869the 'upgrade' target.
f419daca 870